SystemOrganization addCategory: #'JQueryMobile-Core-Configuration'!

WASystemConfiguration subclass: #JQMConfigurator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Core-Configuration'!

!JQMConfigurator class methodsFor: 'defaults' stamp: 'NickAger 9/9/2012 19:13'!
defaultFileLibrary 
	^ JQMLocalDeploymentLibrary! !

!JQMConfigurator methodsFor: 'description' stamp: 'NickAger 9/9/2012 19:45'!
describeOn: config
	(config list: #jqmFileLibrary)
		group: #jqueryMobile;
		options: [ self fileLibraries ];
		comment: 'Choose from local/CDN hosted urls and development or minimized deployment libraries';
		default: self class defaultFileLibrary! !

!JQMConfigurator methodsFor: 'accessing' stamp: 'NickAger 9/9/2012 16:43'!
fileLibraries
	^ Array
		with: JQMLocalDeploymentLibrary
		with: JQMLocalDevelopmentLibrary
		with: JQMDeploymentLibrary
		with: JQMDevelopmentLibrary
		with: JQMDailyBuildsLibrary! !

!WAApplication methodsFor: '*jquerymobile-core-configuration' stamp: 'NickAger 9/9/2012 19:34'!
jqmFileLibrary
	| jqmFileLibrary |
	
	[
		"Note: with Seaside 3.1 this can be simplified by using the method #preferenceAt:ifAbsent: "
		jqmFileLibrary := self preferenceAt: #jqmFileLibrary ]
		on: WAAttributeNotFound
		do: [ :err |
			WAError signal: 'JQuery Mobile now includes a configuration (JQMConfigurator) which allows you to specify the file library to use. However the JQM configuration is not setup for this application. Re-register the application with JQMAdmin class>>#register:ApplicationAt: and this exception will not occur.' ].
		
	^ jqmFileLibrary default "return instance"! !
